

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>posydon.visualization.plot1D &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/doctools.js"></script>
        <script src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html" class="icon icon-home"></a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>posydon.visualization.plot1D</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for posydon.visualization.plot1D</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;Plotting class for 1D (MESA) psygrids.</span>

<span class="sd">The 2D visualization plotting class allows to plot 1D tracks of PsyGrid</span>
<span class="sd">objects. The PsyGrid object is composed of nD MESA grid run with POSYDON</span>
<span class="sd">and post processed with the psygrid object into an h5 file.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;Simone Bavera &lt;Simone.Bavera@unige.ch&gt;&quot;</span><span class="p">]</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="k">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">posydon.utils.constants</span> <span class="k">as</span> <span class="nn">const</span>
<span class="kn">from</span> <span class="nn">labellines</span> <span class="kn">import</span> <span class="n">labelLine</span>
<span class="kn">from</span> <span class="nn">posydon.visualization.plot_defaults</span> <span class="kn">import</span> <span class="n">PLOT_PROPERTIES</span>
<span class="kn">from</span> <span class="nn">posydon.visualization.plot_defaults</span> <span class="kn">import</span> <span class="n">DEFAULT_LABELS</span>


<div class="viewcode-block" id="plot1D"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D">[docs]</a><span class="k">class</span> <span class="nc">plot1D</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Plotting class for 1D (MESA) grids.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
        <span class="bp">self</span><span class="p">,</span>
        <span class="n">run</span><span class="p">,</span>
        <span class="n">x_var_str</span><span class="p">,</span>
        <span class="n">y_var_str</span><span class="p">,</span>
        <span class="n">z_var_str</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
        <span class="n">history</span><span class="o">=</span><span class="s2">&quot;binary_history&quot;</span><span class="p">,</span>
        <span class="n">HR</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
        <span class="n">verbose</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
        <span class="o">**</span><span class="n">kwargs</span>
    <span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Read a PsyGrid object and plot a 1D track of x vs y.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        run : int or list of int</span>
<span class="sd">            Index or list of indeces of the PsyGrid object you would like to</span>
<span class="sd">            plot.</span>
<span class="sd">        x_var_str : str</span>
<span class="sd">            String of values to plot on the x axis. Allowed strings are the</span>
<span class="sd">            one in `psygrid.history.dtype.names` where &quot;history&quot; needs to be</span>
<span class="sd">            chosen accordingly.</span>
<span class="sd">        y_var_str : str or list of str</span>
<span class="sd">            String or list of stringvalues to plot on the y axis. Allowed</span>
<span class="sd">            strings are the one in `psygrid.history.dtype.names` where</span>
<span class="sd">            &quot;history&quot; needs to be chosen accordingly.</span>
<span class="sd">        z_var_str : str</span>
<span class="sd">            String of values to plot on the z axis (displayed with a color).</span>
<span class="sd">            Allowed strings are the one in `psygrid.history.dtype.names` where</span>
<span class="sd">            &quot;history&quot; needs to be chosen accordingly.</span>
<span class="sd">        history : str</span>
<span class="sd">            The x, y, z variables are read from either: &quot;binary_history&quot;,</span>
<span class="sd">            &quot;history1&quot;, &quot;history2&quot;.</span>
<span class="sd">        HR : bool</span>
<span class="sd">            If `True`, an HR diagram will be plotted.</span>
<span class="sd">        verbose : bool</span>
<span class="sd">            If `True`, the object reports by printing to standard output.</span>
<span class="sd">        **kwargs : dict</span>
<span class="sd">            Dictionary containing extra visualisation options (cf.</span>
<span class="sd">            `PLOT_PROPERTIES` in `plot_defaults.py`.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">verbose</span> <span class="o">=</span> <span class="n">verbose</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">HR</span> <span class="o">=</span> <span class="n">HR</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">run</span> <span class="o">=</span> <span class="n">run</span>

        <span class="c1"># read kwargs</span>
        <span class="k">for</span> <span class="n">key</span> <span class="ow">in</span> <span class="n">kwargs</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">key</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">PLOT_PROPERTIES</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="n">key</span> <span class="o">+</span> <span class="s2">&quot; is not a valid parameter name!&quot;</span><span class="p">)</span>

        <span class="k">for</span> <span class="n">varname</span> <span class="ow">in</span> <span class="n">PLOT_PROPERTIES</span><span class="p">:</span>
            <span class="n">default_value</span> <span class="o">=</span> <span class="n">PLOT_PROPERTIES</span><span class="p">[</span><span class="n">varname</span><span class="p">]</span>
            <span class="k">if</span> <span class="p">(</span>
                <span class="n">varname</span> <span class="ow">not</span> <span class="ow">in</span> <span class="p">[</span><span class="s2">&quot;colorbar&quot;</span><span class="p">,</span> <span class="s2">&quot;legend1D&quot;</span><span class="p">,</span> <span class="s2">&quot;legend2D&quot;</span><span class="p">]</span>
                <span class="ow">or</span> <span class="n">varname</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">keys</span><span class="p">()</span>
            <span class="p">):</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">varname</span><span class="p">,</span> <span class="n">kwargs</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">varname</span><span class="p">,</span> <span class="n">default_value</span><span class="p">))</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">temp_var</span> <span class="o">=</span> <span class="p">{}</span>
                <span class="k">for</span> <span class="n">sub_varname</span> <span class="ow">in</span> <span class="n">PLOT_PROPERTIES</span><span class="p">[</span><span class="n">varname</span><span class="p">]:</span>
                    <span class="n">default_value</span> <span class="o">=</span> <span class="n">PLOT_PROPERTIES</span><span class="p">[</span><span class="n">varname</span><span class="p">][</span><span class="n">sub_varname</span><span class="p">]</span>
                    <span class="n">temp_var</span><span class="p">[</span><span class="n">sub_varname</span><span class="p">]</span> <span class="o">=</span> <span class="n">kwargs</span><span class="p">[</span><span class="n">varname</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">(</span>
                        <span class="n">sub_varname</span><span class="p">,</span> <span class="n">default_value</span>
                    <span class="p">)</span>
                <span class="nb">setattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">varname</span><span class="p">,</span> <span class="n">temp_var</span><span class="p">)</span>

        <span class="c1"># history</span>
        <span class="k">if</span> <span class="n">history</span> <span class="ow">not</span> <span class="ow">in</span> <span class="p">[</span><span class="s2">&quot;binary_history&quot;</span><span class="p">,</span> <span class="s2">&quot;history1&quot;</span><span class="p">,</span> <span class="s2">&quot;history2&quot;</span><span class="p">]:</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;history is must be either binary_history or history1/2!&quot;</span><span class="p">)</span>

        <span class="c1"># store the history values</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">run</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">history</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">run</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">run</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">run</span><span class="p">[</span><span class="n">history</span><span class="p">])</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">history</span> <span class="o">=</span> <span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">run</span><span class="p">[</span><span class="n">history</span><span class="p">]]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">n_runs</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">history_str</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">dtype</span><span class="o">.</span><span class="n">names</span>

        <span class="c1"># x, y and z variables must exist</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">x_var_str</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">x_var_str</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history_str</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                    <span class="s2">&quot;x_var_str = </span><span class="si">{}</span><span class="s2"> is not available in run.</span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                        <span class="n">x_var_str</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span>
                    <span class="p">)</span>
                <span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">x_var_str</span> <span class="o">=</span> <span class="n">x_var_str</span>
        <span class="k">elif</span> <span class="n">x_var_str</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                <span class="s2">&quot;x_var_str = </span><span class="si">{}</span><span class="s2"> is not available a str type!&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">x_var_str</span><span class="p">)</span>
            <span class="p">)</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">y_var_str</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">y_var_str</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history_str</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                    <span class="s2">&quot;y_var_str = </span><span class="si">{}</span><span class="s2"> is not available in run.</span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                        <span class="n">y_var_str</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span>
                    <span class="p">)</span>
                <span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span> <span class="o">=</span> <span class="n">y_var_str</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span> <span class="o">=</span> <span class="mi">1</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">y_var_str</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
            <span class="k">for</span> <span class="n">var_str</span> <span class="ow">in</span> <span class="n">y_var_str</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">var_str</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history_str</span><span class="p">:</span>
                    <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                        <span class="s2">&quot;y_var_str = </span><span class="si">{}</span><span class="s2"> is not available in run.</span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                            <span class="n">var_str</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span>
                        <span class="p">)</span>
                    <span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span> <span class="o">=</span> <span class="n">y_var_str</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">y_var_str</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">x_var_str</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                <span class="s2">&quot;y_var_str = </span><span class="si">{}</span><span class="s2"> is not available a str type!&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">y_var_str</span><span class="p">)</span>
            <span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span> <span class="o">=</span> <span class="mi">1</span>
        <span class="k">if</span> <span class="n">z_var_str</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">z_var_str</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">z_var_str</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">z_var_str</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history_str</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                    <span class="s2">&quot;z_var_str = </span><span class="si">{}</span><span class="s2"> is not available in run.</span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                        <span class="n">z_var_str</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span>
                    <span class="p">)</span>
                <span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">z_var_str</span> <span class="o">=</span> <span class="n">z_var_str</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span> <span class="o">=</span> <span class="mi">1</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;z_var_str = </span><span class="si">{}</span><span class="s2"> is not str type!&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">z_var_str</span><span class="p">))</span>

    <span class="k">def</span> <span class="fm">__call__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Generate the plot when the class is called.&quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="ow">not</span> <span class="bp">self</span><span class="o">.</span><span class="n">HR</span><span class="p">:</span>

            <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">figsize</span><span class="p">)</span>

            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span> <span class="o">&gt;</span> <span class="mi">1</span><span class="p">:</span>

                <span class="n">i</span> <span class="o">=</span> <span class="mi">1</span>
                <span class="k">for</span> <span class="n">var_str</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">:</span>
                    <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="n">i</span><span class="p">)</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">update_values_to_plot</span><span class="p">(</span><span class="n">var_str</span><span class="p">)</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">plot_panel</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="n">i</span><span class="p">,</span> <span class="n">var_str</span><span class="p">)</span>
                    <span class="n">i</span> <span class="o">+=</span> <span class="mi">1</span>

                <span class="c1"># adjust spacing</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">subplots_adjust</span><span class="p">(</span><span class="n">wspace</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">wspace</span><span class="p">,</span> <span class="n">hspace</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">hspace</span><span class="p">)</span>

            <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
                <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">z_var_str</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">)</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">update_values_to_plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">)</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">plot_panel</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">)</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">update_values_to_plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">)</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">plot_panel</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="mi">1</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                    <span class="s2">&quot;number_of_plots=</span><span class="si">{}</span><span class="s2"> must be a positive integer!&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span>
                    <span class="p">)</span>
                <span class="p">)</span>

            <span class="c1"># add title</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="n">fig</span><span class="p">)</span>

            <span class="c1"># save figure</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">fname</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="n">fig</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">path_to_file</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">fname</span><span class="p">,</span> <span class="n">bbox_inches</span><span class="o">=</span><span class="s2">&quot;tight&quot;</span><span class="p">)</span>

            <span class="c1"># show figure</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">show_fig</span><span class="p">:</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

            <span class="n">plt</span><span class="o">.</span><span class="n">close</span><span class="p">(</span><span class="n">fig</span><span class="p">)</span>

        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">HR_diagram</span><span class="p">()</span>

<div class="viewcode-block" id="plot1D.plot_panel"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.plot_panel">[docs]</a>    <span class="k">def</span> <span class="nf">plot_panel</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ax</span><span class="p">,</span> <span class="n">i</span><span class="p">,</span> <span class="n">y_var_str</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Plot the 1D pannel.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        ax : object</span>
<span class="sd">            matplotlib figure axes.</span>
<span class="sd">        i : int</span>
<span class="sd">            Index of the run to plot.</span>
<span class="sd">        y_var_str : str</span>
<span class="sd">            String or list of stringvalues to plot on the y axis.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">z_var_str</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>

            <span class="n">lines</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">n_runs</span><span class="p">):</span>
                <span class="p">(</span><span class="n">line</span><span class="p">,)</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x_var</span><span class="p">[</span><span class="n">j</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">y_var</span><span class="p">[</span><span class="n">j</span><span class="p">])</span>
                <span class="n">lines</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">line</span><span class="p">)</span>

            <span class="c1"># add labels and legend</span>
            <span class="k">if</span> <span class="n">i</span> <span class="o">==</span> <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">()</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">set_legend</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="n">lines</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">ax</span><span class="o">.</span><span class="n">set_xticklabels</span><span class="p">([])</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">()</span>

        <span class="k">else</span><span class="p">:</span>

            <span class="n">lines</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">n_runs</span><span class="p">):</span>
                <span class="p">(</span><span class="n">line</span><span class="p">,)</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">x_var</span><span class="p">[</span><span class="n">j</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">y_var</span><span class="p">[</span><span class="n">j</span><span class="p">])</span>
                <span class="n">sc</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">x_var</span><span class="p">[</span><span class="n">j</span><span class="p">],</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">y_var</span><span class="p">[</span><span class="n">j</span><span class="p">],</span>
                    <span class="n">c</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">z_var</span><span class="p">[</span><span class="n">j</span><span class="p">],</span>
                    <span class="n">s</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">marker_size</span><span class="p">,</span>
                    <span class="n">vmin</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">zmin</span><span class="p">,</span>
                    <span class="n">vmax</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">zmax</span><span class="p">,</span>
                <span class="p">)</span>
                <span class="n">lines</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">line</span><span class="p">)</span>

            <span class="c1"># add labels and legend</span>
            <span class="k">if</span> <span class="n">i</span> <span class="o">==</span> <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">()</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">set_legend</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="n">lines</span><span class="p">)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">set_color_bar</span><span class="p">(</span><span class="n">sc</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">ax</span><span class="o">.</span><span class="n">set_xticklabels</span><span class="p">([])</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="n">i</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">()</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">()</span></div>

<div class="viewcode-block" id="plot1D.update_values_to_plot"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.update_values_to_plot">[docs]</a>    <span class="k">def</span> <span class="nf">update_values_to_plot</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">y_var_str</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Update all values to plot.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        y_var_str : str</span>
<span class="sd">            String or list of stringvalues to plot on the y axis.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># save values to plot</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">log10_x</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_var</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">history</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">x_var</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">history</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x_var_str</span><span class="p">]))</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">x_var</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">history</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">x_var</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">history</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x_var_str</span><span class="p">])</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">log10_y</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">y_var</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">history</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">y_var</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">history</span><span class="p">[</span><span class="n">y_var_str</span><span class="p">]))</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">y_var</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">history</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">y_var</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">history</span><span class="p">[</span><span class="n">y_var_str</span><span class="p">])</span>

        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">z_var_str</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">log10_z</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">z_var</span> <span class="o">=</span> <span class="p">[]</span>
                <span class="k">for</span> <span class="n">history</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">z_var</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">history</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">z_var_str</span><span class="p">]))</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">z_var</span> <span class="o">=</span> <span class="p">[]</span>
                <span class="k">for</span> <span class="n">history</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">z_var</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">history</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">z_var_str</span><span class="p">])</span>

            <span class="c1"># ensure to have the minimal value for many tracks scatter plots</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">zmin</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">zmin</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">z_var</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
                <span class="k">for</span> <span class="n">z_var</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">z_var</span><span class="p">:</span>
                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">zmin</span> <span class="o">&gt;</span> <span class="nb">min</span><span class="p">(</span><span class="n">z_var</span><span class="p">):</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">zmin</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="n">z_var</span><span class="p">)</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">zmax</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">zmax</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">z_var</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
                <span class="k">for</span> <span class="n">z_var</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">z_var</span><span class="p">:</span>
                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">zmax</span> <span class="o">&lt;</span> <span class="nb">max</span><span class="p">(</span><span class="n">z_var</span><span class="p">):</span>
                        <span class="bp">self</span><span class="o">.</span><span class="n">zmax</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">z_var</span><span class="p">)</span></div>

<div class="viewcode-block" id="plot1D.set_title"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.set_title">[docs]</a>    <span class="k">def</span> <span class="nf">set_title</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">fig</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add title.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        fig : object</span>
<span class="sd">            matplotlib figure object.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">title</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">title</span><span class="p">,</span> <span class="n">fontdict</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">title_font_dict</span><span class="p">,</span> <span class="n">loc</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">title_loc</span><span class="p">)</span>
        <span class="k">elif</span> <span class="bp">self</span><span class="o">.</span><span class="n">title</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">number_of_plots</span> <span class="o">&gt;</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">fig</span><span class="o">.</span><span class="n">suptitle</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">title</span><span class="p">,</span> <span class="n">fontdict</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">title_font_dict</span><span class="p">)</span></div>

<div class="viewcode-block" id="plot1D.set_xlabel"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.set_xlabel">[docs]</a>    <span class="k">def</span> <span class="nf">set_xlabel</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add x label.&quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">xlabel</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">xlabel</span><span class="p">,</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">xlabel_kwargs</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">log10_x</span><span class="p">:</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="n">DEFAULT_LABELS</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x_var_str</span><span class="p">][</span><span class="mi">1</span><span class="p">],</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">xlabel_kwargs</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="n">DEFAULT_LABELS</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">x_var_str</span><span class="p">][</span><span class="mi">0</span><span class="p">],</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">xlabel_kwargs</span><span class="p">)</span></div>

<div class="viewcode-block" id="plot1D.set_ylabel"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.set_ylabel">[docs]</a>    <span class="k">def</span> <span class="nf">set_ylabel</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">i</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add y label.&quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">ylabel</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel</span><span class="p">,</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel_kwargs</span><span class="p">)</span>
            <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
                <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel</span><span class="p">[</span><span class="n">i</span> <span class="o">-</span> <span class="mi">1</span><span class="p">],</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel_kwargs</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">log10_y</span><span class="p">:</span>
                <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="n">DEFAULT_LABELS</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">][</span><span class="mi">1</span><span class="p">],</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel_kwargs</span><span class="p">)</span>
                <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span>
                        <span class="n">DEFAULT_LABELS</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">[</span><span class="n">i</span> <span class="o">-</span> <span class="mi">1</span><span class="p">]][</span><span class="mi">1</span><span class="p">],</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel_kwargs</span>
                    <span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">,</span> <span class="nb">str</span><span class="p">):</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="n">DEFAULT_LABELS</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">][</span><span class="mi">0</span><span class="p">],</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel_kwargs</span><span class="p">)</span>
                <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
                    <span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span>
                        <span class="n">DEFAULT_LABELS</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">y_var_str</span><span class="p">[</span><span class="n">i</span> <span class="o">-</span> <span class="mi">1</span><span class="p">]][</span><span class="mi">0</span><span class="p">],</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">ylabel_kwargs</span>
                    <span class="p">)</span></div>

<div class="viewcode-block" id="plot1D.set_xlim"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.set_xlim">[docs]</a>    <span class="k">def</span> <span class="nf">set_xlim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Set x axes limits.&quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmin</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmax</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">xlim</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">xmin</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmax</span><span class="p">)</span></div>

<div class="viewcode-block" id="plot1D.set_ylim"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.set_ylim">[docs]</a>    <span class="k">def</span> <span class="nf">set_ylim</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Set y axes limits.&quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">ymin</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">ymax</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">ylim</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">ymin</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">ymax</span><span class="p">)</span></div>

<div class="viewcode-block" id="plot1D.set_legend"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.set_legend">[docs]</a>    <span class="k">def</span> <span class="nf">set_legend</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">ax</span><span class="p">,</span> <span class="n">lines</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add legend.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        ax : object</span>
<span class="sd">            matplotlib figure axes.</span>
<span class="sd">        lines : object</span>
<span class="sd">            matplotlib lines object.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;lines_legend&quot;</span><span class="p">]</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>

            <span class="c1"># defailt: shrink current axis by 20% and put tje legend to</span>
            <span class="c1"># the right of the current axis</span>
            <span class="n">box</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">get_position</span><span class="p">()</span>
            <span class="n">ax</span><span class="o">.</span><span class="n">set_position</span><span class="p">(</span>
                <span class="p">[</span><span class="n">box</span><span class="o">.</span><span class="n">x0</span><span class="p">,</span> <span class="n">box</span><span class="o">.</span><span class="n">y0</span><span class="p">,</span> <span class="n">box</span><span class="o">.</span><span class="n">width</span> <span class="o">*</span> <span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;shrink_box&quot;</span><span class="p">],</span> <span class="n">box</span><span class="o">.</span><span class="n">height</span><span class="p">]</span>
            <span class="p">)</span>

            <span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span>
                <span class="n">lines</span><span class="p">,</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;lines_legend&quot;</span><span class="p">],</span>
                <span class="n">borderaxespad</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;borderaxespad&quot;</span><span class="p">],</span>
                <span class="n">handletextpad</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;handletextpad&quot;</span><span class="p">],</span>
                <span class="n">columnspacing</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;columnspacing&quot;</span><span class="p">],</span>
                <span class="n">title</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;title&quot;</span><span class="p">],</span>
                <span class="n">title_fontsize</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;title_font_size&quot;</span><span class="p">],</span>
                <span class="n">prop</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;prop&quot;</span><span class="p">],</span>
                <span class="n">loc</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;loc&quot;</span><span class="p">],</span>
                <span class="n">ncol</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;ncol&quot;</span><span class="p">],</span>
                <span class="n">bbox_to_anchor</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">legend1D</span><span class="p">[</span><span class="s2">&quot;bbox_to_anchor&quot;</span><span class="p">],</span>
            <span class="p">)</span></div>

<div class="viewcode-block" id="plot1D.set_color_bar"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.set_color_bar">[docs]</a>    <span class="k">def</span> <span class="nf">set_color_bar</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">scatter</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Add colorbar.</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        scatters : object</span>
<span class="sd">            matplotlib scatter object.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">colorbar</span><span class="p">(</span>
            <span class="n">mappable</span><span class="o">=</span><span class="n">scatter</span><span class="p">,</span>
            <span class="n">orientation</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;orientation&quot;</span><span class="p">],</span>
            <span class="n">fraction</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;fraction&quot;</span><span class="p">],</span>
            <span class="n">pad</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;pad&quot;</span><span class="p">],</span>
            <span class="n">shrink</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;shrink&quot;</span><span class="p">],</span>
            <span class="n">aspect</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;aspect&quot;</span><span class="p">],</span>
            <span class="n">anchor</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;anchor&quot;</span><span class="p">],</span>
            <span class="n">panchor</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;panchor&quot;</span><span class="p">],</span>
            <span class="n">extend</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;extend&quot;</span><span class="p">],</span>
        <span class="p">)</span><span class="o">.</span><span class="n">set_label</span><span class="p">(</span><span class="n">label</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;label&quot;</span><span class="p">],</span> <span class="n">size</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">colorbar</span><span class="p">[</span><span class="s2">&quot;label_size&quot;</span><span class="p">])</span></div>

<div class="viewcode-block" id="plot1D.lines_constant_radius"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.lines_constant_radius">[docs]</a>    <span class="k">def</span> <span class="nf">lines_constant_radius</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Constant radius lines for the HR diagram.&quot;&quot;&quot;</span>

        <span class="k">def</span> <span class="nf">luminosity</span><span class="p">(</span><span class="n">Teff</span><span class="p">,</span> <span class="n">R</span><span class="p">):</span>
            <span class="k">return</span> <span class="p">(</span>
                <span class="mi">4</span>
                <span class="o">*</span> <span class="n">np</span><span class="o">.</span><span class="n">pi</span>
                <span class="o">*</span> <span class="n">const</span><span class="o">.</span><span class="n">boltz_sigma</span>
                <span class="o">*</span> <span class="n">Teff</span> <span class="o">**</span> <span class="mi">4</span>
                <span class="o">*</span> <span class="p">(</span><span class="n">R</span> <span class="o">*</span> <span class="n">const</span><span class="o">.</span><span class="n">Rsun</span><span class="p">)</span> <span class="o">**</span> <span class="mi">2</span>
                <span class="o">/</span> <span class="n">const</span><span class="o">.</span><span class="n">Lsun</span>
            <span class="p">)</span>

        <span class="c1"># constan radius line</span>
        <span class="n">Teff</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">1000</span><span class="p">,</span> <span class="mi">1000000</span><span class="p">,</span> <span class="mi">1000</span><span class="p">)</span>
        <span class="k">return</span> <span class="p">(</span>
            <span class="p">[</span><span class="sa">r</span><span class="s2">&quot;1 $R_\odot$&quot;</span><span class="p">,</span> <span class="sa">r</span><span class="s2">&quot;10 $R_\odot$&quot;</span><span class="p">,</span> <span class="sa">r</span><span class="s2">&quot;100 $R_\odot$&quot;</span><span class="p">,</span> <span class="sa">r</span><span class="s2">&quot;1000 $R_\odot$&quot;</span><span class="p">],</span>
            <span class="n">Teff</span><span class="p">,</span>
            <span class="p">[</span>
                <span class="n">luminosity</span><span class="p">(</span><span class="n">Teff</span><span class="p">,</span> <span class="n">R</span><span class="o">=</span><span class="mi">1</span><span class="p">),</span>
                <span class="n">luminosity</span><span class="p">(</span><span class="n">Teff</span><span class="p">,</span> <span class="n">R</span><span class="o">=</span><span class="mi">10</span><span class="p">),</span>
                <span class="n">luminosity</span><span class="p">(</span><span class="n">Teff</span><span class="p">,</span> <span class="n">R</span><span class="o">=</span><span class="mi">100</span><span class="p">),</span>
                <span class="n">luminosity</span><span class="p">(</span><span class="n">Teff</span><span class="p">,</span> <span class="n">R</span><span class="o">=</span><span class="mi">1000</span><span class="p">),</span>
            <span class="p">],</span>
        <span class="p">)</span></div>

<div class="viewcode-block" id="plot1D.HR_diagram"><a class="viewcode-back" href="../../../api/posydon.visualization.plot1D.html#posydon.visualization.plot1D.plot1D.HR_diagram">[docs]</a>    <span class="k">def</span> <span class="nf">HR_diagram</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Plot and HR diagram.&quot;&quot;&quot;</span>

        <span class="k">if</span> <span class="s2">&quot;log_Teff&quot;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history_str</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span>
                <span class="s2">&quot;You cannot plot an HR diagram without log_Teff in history!&quot;</span>
            <span class="p">)</span>

        <span class="k">if</span> <span class="s2">&quot;log_L&quot;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">history_str</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">ValueError</span><span class="p">(</span><span class="s2">&quot;You cannot plot an HR diagram without log_L in history!&quot;</span><span class="p">)</span>

        <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">figsize</span><span class="p">)</span>
        <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">)</span>

        <span class="n">lines</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">n_runs</span><span class="p">):</span>
            <span class="p">(</span><span class="n">line</span><span class="p">,)</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_Teff&quot;</span><span class="p">],</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_L&quot;</span><span class="p">],</span>
            <span class="p">)</span>
            <span class="n">lines</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">line</span><span class="p">)</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmin</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">xmin</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_Teff&quot;</span><span class="p">])</span> <span class="o">*</span> <span class="mf">0.98</span>
            <span class="k">elif</span> <span class="nb">min</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_Teff&quot;</span><span class="p">])</span> <span class="o">&lt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmin</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">xmin</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_Teff&quot;</span><span class="p">])</span> <span class="o">*</span> <span class="mf">0.98</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmax</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">xmax</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_Teff&quot;</span><span class="p">])</span> <span class="o">*</span> <span class="mf">1.02</span>
            <span class="k">elif</span> <span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_Teff&quot;</span><span class="p">])</span> <span class="o">&gt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmax</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">xmax</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_Teff&quot;</span><span class="p">])</span> <span class="o">*</span> <span class="mf">1.02</span>

            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">ymin</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">ymin</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_L&quot;</span><span class="p">])</span> <span class="o">*</span> <span class="mf">0.98</span>
            <span class="k">elif</span> <span class="nb">min</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_L&quot;</span><span class="p">])</span> <span class="o">&lt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">ymin</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">ymin</span> <span class="o">=</span> <span class="nb">min</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_L&quot;</span><span class="p">])</span> <span class="o">*</span> <span class="mf">0.98</span>
            <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">ymax</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">ymax</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_L&quot;</span><span class="p">])</span> <span class="o">*</span> <span class="mf">1.02</span>
            <span class="k">elif</span> <span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_L&quot;</span><span class="p">])</span> <span class="o">&gt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">ymax</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">ymax</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">history</span><span class="p">[</span><span class="n">j</span><span class="p">][</span><span class="s2">&quot;log_L&quot;</span><span class="p">])</span> <span class="o">*</span> <span class="mf">1.02</span>

        <span class="c1"># flip axes</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">invert_xaxis</span><span class="p">()</span>

        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">const_R_lines</span><span class="p">:</span>
            <span class="n">handels</span><span class="p">,</span> <span class="n">Teff</span><span class="p">,</span> <span class="n">luminosities</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">lines_constant_radius</span><span class="p">()</span>
            <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">L</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">luminosities</span><span class="p">):</span>
                <span class="n">slice_T</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">logical_and</span><span class="p">(</span>
                    <span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">Teff</span><span class="p">)</span> <span class="o">&gt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmin</span> <span class="o">*</span> <span class="mf">0.98</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">Teff</span><span class="p">)</span> <span class="o">&lt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmax</span> <span class="o">*</span> <span class="mf">1.02</span>
                <span class="p">)</span>
                <span class="n">slice_L</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">logical_and</span><span class="p">(</span>
                    <span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">L</span><span class="p">)</span> <span class="o">&gt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">ymin</span> <span class="o">*</span> <span class="mf">0.98</span><span class="p">,</span> <span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">L</span><span class="p">)</span> <span class="o">&lt;</span> <span class="bp">self</span><span class="o">.</span><span class="n">ymax</span> <span class="o">*</span> <span class="mf">1.02</span>
                <span class="p">)</span>
                <span class="nb">slice</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">logical_and</span><span class="p">(</span><span class="n">slice_T</span><span class="p">,</span> <span class="n">slice_L</span><span class="p">)</span>
                <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">Teff</span><span class="p">[</span><span class="nb">slice</span><span class="p">])</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                    <span class="p">(</span><span class="n">line</span><span class="p">,)</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span>
                        <span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">Teff</span><span class="p">[</span><span class="nb">slice</span><span class="p">]),</span>
                        <span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">L</span><span class="p">[</span><span class="nb">slice</span><span class="p">]),</span>
                        <span class="s2">&quot;-.&quot;</span><span class="p">,</span>
                        <span class="n">color</span><span class="o">=</span><span class="s2">&quot;gray&quot;</span><span class="p">,</span>
                        <span class="n">linewidth</span><span class="o">=</span><span class="mi">3</span><span class="p">,</span>
                    <span class="p">)</span>

                    <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmax</span> <span class="o">&gt;</span> <span class="nb">max</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">Teff</span><span class="p">[</span><span class="nb">slice</span><span class="p">])):</span>
                        <span class="n">x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">log10</span><span class="p">(</span><span class="n">Teff</span><span class="p">[</span><span class="nb">slice</span><span class="p">])[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">*</span> <span class="mf">0.99</span>
                    <span class="k">else</span><span class="p">:</span>
                        <span class="n">x</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">xmax</span> <span class="o">*</span> <span class="mf">0.99</span>
                    <span class="n">labelLine</span><span class="p">(</span><span class="n">line</span><span class="p">,</span> <span class="n">x</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="n">handels</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">align</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">xlabel</span> <span class="o">=</span> <span class="sa">r</span><span class="s2">&quot;$\log_</span><span class="si">{10}</span><span class="s2">(T_\mathrm</span><span class="si">{eff}</span><span class="s2">/[K])$&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">ylabel</span> <span class="o">=</span> <span class="sa">r</span><span class="s2">&quot;$\log_</span><span class="si">{10}</span><span class="s2">(L/[L_\odot])$&quot;</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="n">fig</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">()</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">invert_xaxis</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">set_legend</span><span class="p">(</span><span class="n">ax</span><span class="p">,</span> <span class="n">lines</span><span class="p">)</span>
        <span class="c1"># save figure</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">fname</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">fig</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">path_to_file</span> <span class="o">+</span> <span class="bp">self</span><span class="o">.</span><span class="n">fname</span><span class="p">,</span> <span class="n">bbox_inches</span><span class="o">=</span><span class="s2">&quot;tight&quot;</span><span class="p">)</span>

        <span class="c1"># show figure</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">show_fig</span><span class="p">:</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

        <span class="n">plt</span><span class="o">.</span><span class="n">close</span><span class="p">(</span><span class="n">fig</span><span class="p">)</span></div></div>
</pre></div>

           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>